diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/eht/eht-operation.cc ns-3.38/src/wifi/model/eht/eht-operation.cc
--- ns-3.37/src/wifi/model/eht/eht-operation.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/wifi/model/eht/eht-operation.cc	2023-03-16 20:54:23.856869200 -0700
@@ -0,0 +1,293 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2022
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sharan Naribole <sharan.naribole@gmail.com>
+ */
+
+#include "eht-operation.h"
+
+#include <ns3/assert.h>
+
+#include <algorithm>
+
+namespace ns3
+{
+
+void
+EhtOperation::EhtOpParams::Serialize(Buffer::Iterator& start) const
+{
+    uint8_t val = opInfoPresent | (disabledSubchBmPresent << 1) | (defaultPeDur << 2) |
+                  (grpBuIndLimit << 3) | (grpBuExp << 4);
+    start.WriteU8(val);
+}
+
+uint16_t
+EhtOperation::EhtOpParams::Deserialize(Buffer::Iterator start)
+{
+    auto params = start.ReadU8();
+    opInfoPresent = params & 0x01;
+    disabledSubchBmPresent = (params >> 1) & 0x01;
+    defaultPeDur = (params >> 2) & 0x01;
+    grpBuIndLimit = (params >> 3) & 0x01;
+    grpBuExp = (params >> 4) & 0x03;
+    return WIFI_EHT_OP_PARAMS_SIZE_B;
+}
+
+/**
+ * set the max Tx/Rx NSS for input MCS index range
+ * \param vec vector of max NSS per MCS
+ * \param maxNss max NSS for input MCS range
+ * \param mcsStart MCS index start
+ * \param mcsEnd MCS index end
+ */
+void
+SetMaxNss(std::vector<uint8_t>& vec, uint8_t maxNss, uint8_t mcsStart, uint8_t mcsEnd)
+{
+    NS_ASSERT(mcsStart <= mcsEnd);
+    NS_ASSERT((mcsStart >= 0) && (mcsEnd <= WIFI_EHT_MAX_MCS_INDEX));
+    NS_ASSERT((maxNss >= 1) && (maxNss <= WIFI_EHT_MAX_NSS_CONFIGURABLE));
+    for (auto index = mcsStart; index <= mcsEnd; index++)
+    {
+        vec[index] = maxNss;
+    }
+}
+
+/**
+ * Get the max Tx/Rx NSS for input MCS index range
+ * \param vec vector of max NSS per MCS
+ * \param mcsStart MCS index start
+ * \param mcsEnd MCS index end
+ * \return max Rx NSS
+ */
+uint32_t
+GetMaxNss(const std::vector<uint8_t>& vec, uint8_t mcsStart, uint8_t mcsEnd)
+{
+    NS_ASSERT(mcsStart <= mcsEnd);
+    NS_ASSERT((mcsStart >= 0) && (mcsEnd <= WIFI_EHT_MAX_MCS_INDEX));
+    auto minMaxNss = WIFI_EHT_MAX_NSS_CONFIGURABLE;
+    for (auto index = mcsStart; index <= mcsEnd; index++)
+    {
+        if (vec[index] < minMaxNss)
+        {
+            minMaxNss = vec[index];
+        }
+    }
+    return minMaxNss;
+}
+
+void
+EhtOperation::EhtBasicMcsNssSet::Serialize(Buffer::Iterator& start) const
+{
+    uint32_t val = GetMaxNss(maxRxNss, 0, 7) | (GetMaxNss(maxTxNss, 0, 7) << 4) |
+                   (GetMaxNss(maxRxNss, 8, 9) << 8) | (GetMaxNss(maxTxNss, 8, 9) << 12) |
+                   (GetMaxNss(maxRxNss, 10, 11) << 16) | (GetMaxNss(maxTxNss, 10, 11) << 20) |
+                   (GetMaxNss(maxRxNss, 12, 13) << 24) | (GetMaxNss(maxTxNss, 12, 13) << 28);
+    start.WriteHtolsbU32(val);
+}
+
+uint16_t
+EhtOperation::EhtBasicMcsNssSet::Deserialize(Buffer::Iterator start)
+{
+    auto subfield = start.ReadLsbtohU32();
+    auto rxNssMcs0_7 = subfield & 0xf; // Max Rx NSS MCS 0-7
+    SetMaxNss(maxRxNss, rxNssMcs0_7, 0, 7);
+    auto txNssMcs0_7 = (subfield >> 4) & 0xf; // Max Tx NSS MCS 0-7
+    SetMaxNss(maxTxNss, txNssMcs0_7, 0, 7);
+    auto rxNssMcs8_9 = (subfield >> 8) & 0xf; // Max Rx NSS MCS 8-9
+    SetMaxNss(maxRxNss, rxNssMcs8_9, 8, 9);
+    auto txNssMcs8_9 = (subfield >> 12) & 0xf; // Max Tx NSS MCS 8-9
+    SetMaxNss(maxTxNss, txNssMcs8_9, 8, 9);
+    auto rxNssMcs10_11 = (subfield >> 16) & 0xf; // Max Rx NSS MCS 10-11
+    SetMaxNss(maxRxNss, rxNssMcs10_11, 10, 11);
+    auto txNssMcs10_11 = (subfield >> 20) & 0xf; // Max Tx NSS MCS 10-11
+    SetMaxNss(maxTxNss, txNssMcs10_11, 10, 11);
+    auto rxNssMcs12_13 = (subfield >> 24) & 0xf; // Max Rx NSS MCS 12-13
+    SetMaxNss(maxRxNss, rxNssMcs12_13, 12, 13);
+    auto txNssMcs12_13 = (subfield >> 28) & 0xf; // Max Tx NSS MCS 12-13
+    SetMaxNss(maxTxNss, txNssMcs12_13, 12, 13);
+    return WIFI_EHT_BASIC_MCS_NSS_SET_SIZE_B;
+}
+
+void
+EhtOperation::EhtOpInfo::Serialize(Buffer::Iterator& start) const
+{
+    start.WriteU8(control.channelWidth); // Control
+    start.WriteU8(ccfs0);                // CCFS 0
+    start.WriteU8(ccfs1);                // CCFS 1
+    if (disabledSubchBm.has_value())
+    {
+        start.WriteU16(disabledSubchBm.value());
+    }
+}
+
+uint16_t
+EhtOperation::EhtOpInfo::Deserialize(Buffer::Iterator start, bool disabledSubchBmPresent)
+{
+    auto i = start;
+    uint16_t count = 0;
+    auto controlSubfield = i.ReadU8();
+    count++;
+    control.channelWidth = controlSubfield & 0x7;
+    ccfs0 = i.ReadU8();
+    count++;
+    ccfs1 = i.ReadU8();
+    count++;
+    NS_ASSERT_MSG(count == WIFI_EHT_OP_INFO_BASIC_SIZE_B,
+                  "Incorrect EHT Operation Info deserialize");
+    if (!disabledSubchBmPresent)
+    {
+        return count;
+    }
+    disabledSubchBm = i.ReadU16();
+    count += 2;
+    NS_ASSERT_MSG(count == WIFI_EHT_OP_INFO_BASIC_SIZE_B + WIFI_EHT_DISABLED_SUBCH_BM_SIZE_B,
+                  "Incorrect EHT Operation Info deserialize");
+    return count;
+}
+
+EhtOperation::EhtOperation()
+{
+    m_mcsNssSet.maxRxNss.assign(WIFI_EHT_MAX_MCS_INDEX + 1, WIFI_DEFAULT_EHT_MAX_NSS);
+    m_mcsNssSet.maxTxNss.assign(WIFI_EHT_MAX_MCS_INDEX + 1, WIFI_DEFAULT_EHT_MAX_NSS);
+}
+
+WifiInformationElementId
+EhtOperation::ElementId() const
+{
+    return IE_EXTENSION;
+}
+
+WifiInformationElementId
+EhtOperation::ElementIdExt() const
+{
+    return IE_EXT_EHT_OPERATION;
+}
+
+uint16_t
+EhtOperation::GetInformationFieldSize() const
+{
+    // IEEE 802.11be D2.0 9.4.2.311
+    auto ret =
+        WIFI_IE_ELEMENT_ID_EXT_SIZE + WIFI_EHT_OP_PARAMS_SIZE_B + WIFI_EHT_BASIC_MCS_NSS_SET_SIZE_B;
+    if (!m_params.opInfoPresent)
+    {
+        return ret;
+    }
+    ret += WIFI_EHT_OP_INFO_BASIC_SIZE_B;
+    if (!m_params.disabledSubchBmPresent)
+    {
+        return ret;
+    }
+    return ret + WIFI_EHT_DISABLED_SUBCH_BM_SIZE_B;
+}
+
+void
+EhtOperation::SetMaxRxNss(uint8_t maxNss, uint8_t mcsStart, uint8_t mcsEnd)
+{
+    NS_ASSERT(mcsStart <= mcsEnd);
+    NS_ASSERT((mcsStart >= 0) && (mcsEnd <= WIFI_EHT_MAX_MCS_INDEX));
+    NS_ASSERT((maxNss >= 1) && (maxNss <= WIFI_EHT_MAX_NSS_CONFIGURABLE));
+    SetMaxNss(m_mcsNssSet.maxRxNss, maxNss, mcsStart, mcsEnd);
+}
+
+void
+EhtOperation::SetMaxTxNss(uint8_t maxNss, uint8_t mcsStart, uint8_t mcsEnd)
+{
+    NS_ASSERT(mcsStart <= mcsEnd);
+    NS_ASSERT((mcsStart >= 0) && (mcsEnd <= WIFI_EHT_MAX_MCS_INDEX));
+    NS_ASSERT((maxNss >= 1) && (maxNss <= WIFI_EHT_MAX_NSS_CONFIGURABLE));
+    SetMaxNss(m_mcsNssSet.maxTxNss, maxNss, mcsStart, mcsEnd);
+}
+
+void
+EhtOperation::SerializeInformationField(Buffer::Iterator start) const
+{
+    m_params.Serialize(start);
+    m_mcsNssSet.Serialize(start);
+    NS_ASSERT_MSG(m_params.opInfoPresent == m_opInfo.has_value(),
+                  "Incorrect setting of EHT Operation Information Present bit");
+
+    if (!m_params.opInfoPresent)
+    { // EHT Operation Information Present not set
+        return;
+    }
+
+    auto disabledSubchBmPresent = m_params.disabledSubchBmPresent > 0;
+    NS_ASSERT_MSG(disabledSubchBmPresent == m_opInfo->disabledSubchBm.has_value(),
+                  "Incorrect setting of Disabled Subchannel Bitmap Present bit");
+    m_opInfo->Serialize(start);
+}
+
+uint16_t
+EhtOperation::DeserializeInformationField(Buffer::Iterator start, uint16_t length)
+{
+    auto i = start;
+    i.Next(m_params.Deserialize(i));
+    i.Next(m_mcsNssSet.Deserialize(i));
+    uint16_t count = i.GetDistanceFrom(start);
+
+    if (!m_params.opInfoPresent)
+    {
+        NS_ASSERT_MSG(count == length, "Unexpected EHT Operation size");
+    }
+
+    if (m_params.opInfoPresent > 0)
+    {
+        auto disabledSubchBmPresent = m_params.disabledSubchBmPresent > 0;
+        m_opInfo = EhtOpInfo();
+        i.Next(m_opInfo->Deserialize(i, disabledSubchBmPresent));
+        count = i.GetDistanceFrom(start);
+    }
+
+    NS_ABORT_MSG_IF(count != length,
+                    "EHT Operation Length (" << +length
+                                             << ") differs "
+                                                "from actual number of bytes read ("
+                                             << +count << ")");
+    return length;
+}
+
+std::ostream&
+operator<<(std::ostream& os, const EhtOperation& ehtOperation)
+{
+    os << +ehtOperation.m_params.opInfoPresent << "|"
+       << +ehtOperation.m_params.disabledSubchBmPresent << "|"
+       << +ehtOperation.m_params.defaultPeDur << "|" << +ehtOperation.m_params.grpBuIndLimit << "|"
+       << +ehtOperation.m_params.grpBuExp << "|[";
+    for (const auto& maxRxNss : ehtOperation.m_mcsNssSet.maxRxNss)
+    {
+        os << +maxRxNss << "|";
+    }
+    os << "]|[";
+    for (const auto& maxTxNss : ehtOperation.m_mcsNssSet.maxTxNss)
+    {
+        os << +maxTxNss << "|";
+    }
+    os << "]";
+    if (ehtOperation.m_opInfo.has_value())
+    {
+        os << "|" << +ehtOperation.m_opInfo->control.channelWidth << "|"
+           << +ehtOperation.m_opInfo->ccfs0 << "|" << +ehtOperation.m_opInfo->ccfs1;
+        if (ehtOperation.m_opInfo->disabledSubchBm.has_value())
+        {
+            os << "|" << ehtOperation.m_opInfo->disabledSubchBm.value();
+        }
+    }
+    return os;
+}
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/eht/eht-operation.h ns-3.38/src/wifi/model/eht/eht-operation.h
--- ns-3.37/src/wifi/model/eht/eht-operation.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/wifi/model/eht/eht-operation.h	2023-03-16 20:54:23.856869200 -0700
@@ -0,0 +1,202 @@
+/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2022
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sharan Naribole <sharan.naribole@gmail.com>
+ */
+
+#ifndef EHT_OPERATION_H
+#define EHT_OPERATION_H
+
+#include <ns3/wifi-information-element.h>
+
+#include <optional>
+#include <vector>
+
+namespace ns3
+{
+
+/// IEEE 802.11be D2.0 Figure 9-1002ai
+constexpr uint8_t WIFI_EHT_MAX_MCS_INDEX = 13;
+/// IEEE 802.11be D2.0 Figure 9-1002b
+constexpr uint16_t WIFI_EHT_OP_PARAMS_SIZE_B = 1;
+/// IEEE 802.11be D2.0 Figure 9-1002c
+constexpr uint16_t WIFI_EHT_OP_INFO_BASIC_SIZE_B = 3;
+/// IEEE 802.11be D2.0 Figure 9-1002c
+constexpr uint16_t WIFI_EHT_DISABLED_SUBCH_BM_SIZE_B = 2;
+/// IEEE 802.11be D2.0 Figure 9-1002ai
+constexpr uint16_t WIFI_EHT_BASIC_MCS_NSS_SET_SIZE_B = 4;
+/// Default max Tx/Rx NSS
+constexpr uint8_t WIFI_DEFAULT_EHT_MAX_NSS = 1;
+/// Max NSS configurable, 802.11be D2.0 Table 9-401m
+constexpr uint8_t WIFI_EHT_MAX_NSS_CONFIGURABLE = 8;
+/// Default EHT Operation Info Present
+constexpr uint8_t WIFI_DEFAULT_EHT_OP_INFO_PRESENT = 0;
+/// Default Disabled Subch Bitmap Present
+constexpr uint8_t WIFI_DEFAULT_EHT_OP_DIS_SUBCH_BM_PRESENT = 0;
+/// Default PE Duration
+constexpr uint8_t WIFI_DEFAULT_EHT_OP_PE_DUR = 0;
+/// Default Group Addressed BU Indication Limit
+constexpr uint8_t WIFI_DEFAULT_GRP_BU_IND_LIMIT = 0;
+/// Default Group Addressed BU Exponent
+constexpr uint8_t WIFI_DEFAULT_GRP_BU_EXP = 0;
+
+/**
+ * \brief EHT Operation Information Element
+ * \ingroup wifi
+ *
+ * This class serializes and deserializes
+ * the EHT Operation Information Element
+ * IEEE 802.11be D2.0 9.4.2.311
+ *
+ */
+class EhtOperation : public WifiInformationElement
+{
+  public:
+    /**
+     * EHT Operation Parameters subfield
+     * IEEE 802.11be D2.0 Figure 9-1002b
+     */
+    struct EhtOpParams
+    {
+        /// EHT Operation Information Present
+        uint8_t opInfoPresent{WIFI_DEFAULT_EHT_OP_INFO_PRESENT};
+        /// Disabled Subchannel Bitmap Present
+        uint8_t disabledSubchBmPresent{WIFI_DEFAULT_EHT_OP_DIS_SUBCH_BM_PRESENT};
+        /// EHT Default PE Duration
+        uint8_t defaultPeDur{WIFI_DEFAULT_EHT_OP_PE_DUR};
+        /// Group Addressed BU Indication Limit
+        uint8_t grpBuIndLimit{WIFI_DEFAULT_GRP_BU_IND_LIMIT};
+        /// Group Addressed BU Indication Exponent
+        uint8_t grpBuExp{WIFI_DEFAULT_GRP_BU_EXP};
+
+        /**
+         * Serialize the EHT Operation Parameters subfield
+         *
+         * \param start iterator pointing to where the subfield should be written to
+         */
+        void Serialize(Buffer::Iterator& start) const;
+        /**
+         * Deserialize the EHT Operation Parameters subfield
+         *
+         * \param start iterator pointing to where the subfield should be read from
+         * \return the number of octets read
+         */
+        uint16_t Deserialize(Buffer::Iterator start);
+    };
+
+    /**
+     * EHT Operation Information Control subfield
+     * IEEE 802.11be D2.0 Figure 9-1002D
+     */
+    struct EhtOpControl
+    {
+        uint8_t channelWidth : 3; ///< EHT BSS bandwidth
+    };
+
+    /**
+     * EHT Operation Information subfield
+     * IEEE 802.11be D2.0 Figure 9-1002c
+     */
+    struct EhtOpInfo
+    {
+        EhtOpControl control;                    ///< Control subfield
+        uint8_t ccfs0;                           ///< Channel center frequency segment 0
+        uint8_t ccfs1;                           ///< Channel center frequency segment 1
+        std::optional<uint16_t> disabledSubchBm; ///< Disabled subchannel bitmap
+
+        /**
+         * Serialize the EHT Operation Information subfield
+         *
+         * \param start iterator pointing to where the subfield should be written to
+         */
+        void Serialize(Buffer::Iterator& start) const;
+        /**
+         * Deserialize the EHT Operation Information subfield
+         *
+         * \param start iterator pointing to where the subfield should be read from
+         * \param disabledSubchBmPresent EHT Operation Param Disabled Subchannel Bitmap Present
+         * \return the number of octets read
+         */
+        uint16_t Deserialize(Buffer::Iterator start, bool disabledSubchBmPresent);
+    };
+
+    /**
+     * Basic EHT-MCS and NSS Set subfield
+     * IEEE 802.11be D2.0 Figure 9-1002ai
+     */
+    struct EhtBasicMcsNssSet
+    {
+        std::vector<uint8_t> maxRxNss{}; ///< Max Rx NSS per MCS
+        std::vector<uint8_t> maxTxNss{}; ///< Max Tx NSS per MCS
+
+        /**
+         * Serialize the Basic EHT-MCS and NSS Set subfield
+         *
+         * \param start iterator pointing to where the subfield should be written to
+         */
+        void Serialize(Buffer::Iterator& start) const;
+        /**
+         * Deserialize the Basic EHT-MCS and NSS Set subfield
+         *
+         * \param start iterator pointing to where the subfield should be read from
+         * \return the number of octets read
+         */
+        uint16_t Deserialize(Buffer::Iterator start);
+    };
+
+    EhtOperation();
+    WifiInformationElementId ElementId() const override;
+    WifiInformationElementId ElementIdExt() const override;
+
+    /**
+     * Set the max Rx NSS for input MCS index range
+     * \param maxNss the maximum supported Rx NSS for MCS group
+     * \param mcsStart MCS index start
+     * \param mcsEnd MCS index end
+     */
+    void SetMaxRxNss(uint8_t maxNss, uint8_t mcsStart, uint8_t mcsEnd);
+    /**
+     * Set the max Tx NSS for input MCS index range
+     * \param maxNss the maximum supported Rx NSS for MCS group
+     * \param mcsStart MCS index start
+     * \param mcsEnd MCS index end
+     */
+    void SetMaxTxNss(uint8_t maxNss, uint8_t mcsStart, uint8_t mcsEnd);
+
+    EhtOpParams m_params;              ///< EHT Operation Parameters
+    EhtBasicMcsNssSet m_mcsNssSet;     ///< Basic EHT-MCS and NSS set
+    std::optional<EhtOpInfo> m_opInfo; ///< EHT Operation Information
+
+  private:
+    uint16_t GetInformationFieldSize() const override;
+    void SerializeInformationField(Buffer::Iterator start) const override;
+    uint16_t DeserializeInformationField(Buffer::Iterator start, uint16_t length) override;
+};
+
+/**
+ * output stream output operator
+ *
+ * \param os output stream
+ * \param ehtOperation the EHT operation
+ *
+ * \returns output stream
+ */
+std::ostream& operator<<(std::ostream& os, const EhtOperation& ehtOperation);
+
+} // namespace ns3
+
+#endif /* EHT_OPERATION_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/eht/eht-phy.cc ns-3.38/src/wifi/model/eht/eht-phy.cc
--- ns-3.37/src/wifi/model/eht/eht-phy.cc	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/eht/eht-phy.cc	2023-03-16 20:54:23.856869200 -0700
@@ -98,6 +98,19 @@
     }
 }
 
+WifiMode
+EhtPhy::GetSigBMode(const WifiTxVector& txVector) const
+{
+    if (txVector.IsDlMu())
+    {
+        return HePhy::GetSigBMode(txVector);
+    }
+    // we get here in case of EHT SU transmission
+    // TODO fix the MCS used for EHT-SIG
+    auto smallestMcs = std::min<uint8_t>(5, txVector.GetMode().GetMcsValue());
+    return VhtPhy::GetVhtMcs(smallestMcs);
+}
+
 Time
 EhtPhy::GetDuration(WifiPpduField field, const WifiTxVector& txVector) const
 {
@@ -116,6 +129,25 @@
     }
 }
 
+Time
+EhtPhy::CalculateNonOfdmaDurationForHeTb(const WifiTxVector& txVector) const
+{
+    Time duration = GetDuration(WIFI_PPDU_FIELD_PREAMBLE, txVector) +
+                    GetDuration(WIFI_PPDU_FIELD_NON_HT_HEADER, txVector) +
+                    GetDuration(WIFI_PPDU_FIELD_U_SIG, txVector);
+    return duration;
+}
+
+Time
+EhtPhy::CalculateNonOfdmaDurationForHeMu(const WifiTxVector& txVector) const
+{
+    Time duration = GetDuration(WIFI_PPDU_FIELD_PREAMBLE, txVector) +
+                    GetDuration(WIFI_PPDU_FIELD_NON_HT_HEADER, txVector) +
+                    GetDuration(WIFI_PPDU_FIELD_U_SIG, txVector) +
+                    GetDuration(WIFI_PPDU_FIELD_EHT_SIG, txVector);
+    return duration;
+}
+
 const PhyEntity::PpduFormats&
 EhtPhy::GetPpduFormats() const
 {
@@ -133,8 +165,7 @@
                            ppduDuration,
                            m_wifiPhy->GetPhyBand(),
                            ObtainNextUid(txVector),
-                           HePpdu::PSD_NON_HE_PORTION,
-                           m_wifiPhy->GetOperatingChannel().GetPrimaryChannelIndex(20));
+                           HePpdu::PSD_NON_HE_PORTION);
 }
 
 PhyEntity::PhyFieldRxStatus
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/eht/eht-phy.h ns-3.38/src/wifi/model/eht/eht-phy.h
--- ns-3.37/src/wifi/model/eht/eht-phy.h	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/eht/eht-phy.h	2023-03-16 20:54:23.856869200 -0700
@@ -64,6 +64,7 @@
     Ptr<WifiPpdu> BuildPpdu(const WifiConstPsduMap& psdus,
                             const WifiTxVector& txVector,
                             Time ppduDuration) override;
+    WifiMode GetSigBMode(const WifiTxVector& txVector) const override;
 
     /**
      * Initialize all EHT modes.
@@ -259,6 +260,9 @@
                                 PhyFieldRxStatus status,
                                 WifiPpduField field) override;
     WifiPhyRxfailureReason GetFailureReason(WifiPpduField field) const override;
+    Time CalculateNonOfdmaDurationForHeTb(const WifiTxVector& txVector) const override;
+    Time CalculateNonOfdmaDurationForHeMu(const WifiTxVector& txVector) const override;
+
     /**
      * Create and return the EHT MCS corresponding to
      * the provided index.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/eht/eht-ppdu.cc ns-3.38/src/wifi/model/eht/eht-ppdu.cc
--- ns-3.37/src/wifi/model/eht/eht-ppdu.cc	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/eht/eht-ppdu.cc	2023-03-16 20:54:23.856869200 -0700
@@ -35,17 +35,24 @@
                  Time ppduDuration,
                  WifiPhyBand band,
                  uint64_t uid,
-                 TxPsdFlag flag,
-                 uint8_t p20Index)
-    : HePpdu(psdus, txVector, txCenterFreq, ppduDuration, band, uid, flag, p20Index)
+                 TxPsdFlag flag)
+    : HePpdu(psdus, txVector, txCenterFreq, ppduDuration, band, uid, flag)
 {
-    NS_LOG_FUNCTION(this << psdus << txVector << txCenterFreq << ppduDuration << band << uid << flag
-                         << p20Index);
-}
+    NS_LOG_FUNCTION(this << psdus << txVector << txCenterFreq << ppduDuration << band << uid
+                         << flag);
 
-EhtPpdu::~EhtPpdu()
-{
-    NS_LOG_FUNCTION(this);
+    // For EHT SU transmissions (carried in EHT MU PPDUs), we have to:
+    // - store the EHT-SIG content channels
+    // - store the MCS and the number of streams for the data field
+    // because this is not done by the parent class.
+    // This is a workaround needed until we properly implement 11be PHY headers.
+    if (ns3::IsDlMu(m_preamble) && !txVector.IsDlMu())
+    {
+        m_contentChannelAlloc = txVector.GetContentChannelAllocation();
+        m_ruAllocation = txVector.GetRuAllocation();
+        m_ehtSuMcs = txVector.GetMode().GetMcsValue();
+        m_ehtSuNStreams = txVector.GetNss();
+    }
 }
 
 WifiPpduType
@@ -79,30 +86,37 @@
     return (m_preamble == WIFI_PREAMBLE_EHT_TB) && !m_muUserInfos.empty();
 }
 
-WifiTxVector
-EhtPpdu::DoGetTxVector() const
-{
-    // FIXME: define EHT PHY headers
-    WifiTxVector txVector;
-    txVector.SetPreambleType(m_preamble);
-    txVector.SetMode(EhtPhy::GetEhtMcs(m_heSig.GetMcs()));
-    txVector.SetChannelWidth(m_heSig.GetChannelWidth());
-    txVector.SetNss(m_heSig.GetNStreams());
-    txVector.SetGuardInterval(m_heSig.GetGuardInterval());
-    txVector.SetBssColor(m_heSig.GetBssColor());
-    txVector.SetLength(m_lSig.GetLength());
+void
+EhtPpdu::SetTxVectorFromPhyHeaders(WifiTxVector& txVector,
+                                   const LSigHeader& lSig,
+                                   const HeSigHeader& heSig) const
+{
+    txVector.SetMode(EhtPhy::GetEhtMcs(m_ehtSuMcs));
+    txVector.SetChannelWidth(heSig.GetChannelWidth());
+    txVector.SetNss(m_ehtSuNStreams);
+    txVector.SetGuardInterval(heSig.GetGuardInterval());
+    txVector.SetBssColor(heSig.GetBssColor());
+    txVector.SetLength(lSig.GetLength());
     txVector.SetAggregation(m_psdus.size() > 1 || m_psdus.begin()->second->IsAggregate());
+    if (!m_muUserInfos.empty())
+    {
+        txVector.SetEhtPpduType(0); // FIXME set to 2 for DL MU-MIMO (non-OFDMA) transmission
+    }
     for (const auto& muUserInfo : m_muUserInfos)
     {
         txVector.SetHeMuUserInfo(muUserInfo.first, muUserInfo.second);
     }
-    return txVector;
+    if (ns3::IsDlMu(m_preamble))
+    {
+        txVector.SetSigBMode(HePhy::GetVhtMcs(heSig.GetMcs()));
+        txVector.SetRuAllocation(m_ruAllocation);
+    }
 }
 
 Ptr<WifiPpdu>
 EhtPpdu::Copy() const
 {
-    return ns3::Copy(Ptr(this));
+    return Ptr<WifiPpdu>(new EhtPpdu(*this), false);
 }
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/eht/eht-ppdu.h ns-3.38/src/wifi/model/eht/eht-ppdu.h
--- ns-3.37/src/wifi/model/eht/eht-ppdu.h	2022-11-01 17:37:24.743395800 -0700
+++ ns-3.38/src/wifi/model/eht/eht-ppdu.h	2023-03-16 20:54:23.856869200 -0700
@@ -52,7 +52,6 @@
      * \param band the WifiPhyBand used for the transmission of this PPDU
      * \param uid the unique ID of this PPDU or of the triggering PPDU if this is an EHT TB PPDU
      * \param flag the flag indicating the type of Tx PSD to build
-     * \param p20Index the index of the primary 20 MHz channel
      */
     EhtPpdu(const WifiConstPsduMap& psdus,
             const WifiTxVector& txVector,
@@ -60,21 +59,21 @@
             Time ppduDuration,
             WifiPhyBand band,
             uint64_t uid,
-            TxPsdFlag flag,
-            uint8_t p20Index);
-    /**
-     * Destructor for EhtPpdu.
-     */
-    ~EhtPpdu() override;
+            TxPsdFlag flag);
 
     WifiPpduType GetType() const override;
     Ptr<WifiPpdu> Copy() const override;
 
-  protected:
+  private:
     bool IsDlMu() const override;
     bool IsUlMu() const override;
-    WifiTxVector DoGetTxVector() const override;
-}; // class EhtPpdu
+    void SetTxVectorFromPhyHeaders(WifiTxVector& txVector,
+                                   const LSigHeader& lSig,
+                                   const HeSigHeader& heSig) const override;
+
+    uint8_t m_ehtSuMcs{0};      //!< EHT-MCS for EHT SU transmissions
+    uint8_t m_ehtSuNStreams{1}; //!< Number of streams for EHT SU transmissions
+};                              // class EhtPpdu
 
 } // namespace ns3
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.37/src/wifi/model/eht/tid-to-link-mapping-element.cc ns-3.38/src/wifi/model/eht/tid-to-link-mapping-element.cc
--- ns-3.37/src/wifi/model/eht/tid-to-link-mapping-element.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.38/src/wifi/model/eht/tid-to-link-mapping-element.cc	2023-03-16 20:54:23.856869200 -0700
@@ -0,0 +1,189 @@
+/*
+ * Copyright (c) 2022
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Sharan Naribole <sharan.naribole@gmail.com>
+ */
+
+#include <ns3/assert.h>
+#include <ns3/tid-to-link-mapping-element.h>
+
+namespace ns3
+{
+
+uint16_t
+TidToLinkMapping::Control::GetSubfieldSize() const
+{
+    // IEEE 802.11be D2.0 Figure 9-1002an
+    NS_ASSERT_MSG(defaultMapping != presenceBitmap.has_value(),
+                  "Presence bitmap not expected if default mapping is set");
+    auto size = WIFI_TID_TO_LINK_MAPPING_CONTROL_BASIC_SIZE_B;
+    if (defaultMapping)
+    {
+        return size;
+    }
+    return size + WIFI_LINK_MAPPING_PRESENCE_IND_SIZE_B;
+}
+
+void
+TidToLinkMapping::Control::Serialize(Buffer::Iterator& start) const
+{
+    uint8_t val = static_cast<uint8_t>(direction);
+    val |= ((defaultMapping ? 1 : 0) << 2);
+    start.WriteU8(val);
+    NS_ASSERT_MSG(defaultMapping != presenceBitmap.has_value(),
+                  "Presence bitmap not expected if default mapping is set");
+    if (presenceBitmap.has_value())
+    {
+        start.WriteU8(presenceBitmap.value());
+    }
+}
+
+uint16_t
+TidToLinkMapping::Control::Deserialize(Buffer::Iterator start)
+{
+    auto i = start;
+    uint8_t count = 0;
+    auto val = i.ReadU8();
+    count++;
+
+    direction = static_cast<TidLinkMapDir>(val & 0x03);
+    defaultMapping = (((val >> 2) & 0x01) == 1);
+    if (defaultMapping)
+    {
+        return count;
+    }
+    presenceBitmap = i.ReadU8();
+    return ++count;
+}
+
+WifiInformationElementId
+TidToLinkMapping::ElementId() const
+{
+    return IE_EXTENSION;
+}
+
+WifiInformationElementId
+TidToLinkMapping::ElementIdExt() const
+{
+    return IE_EXT_TID_TO_LINK_MAPPING_ELEMENT;
+}
+
+void
+TidToLinkMapping::SetLinkMappingOfTid(uint8_t tid, std::list<uint8_t> linkIds)
+{
+    NS_ABORT_MSG_IF(tid > 7, "Invalid tid: " << +tid);
+    NS_ABORT_MSG_IF(m_control.defaultMapping,
+                    "Per-TID link mapping not expected if default mapping is set");
+
+    // derive link mapping for the given TID
+    uint16_t linkMapping = 0;
+
+    for (const auto& linkId : linkIds)
+    {
+        linkMapping |= (1 << linkId);
+    }
+
+    m_linkMapping[tid] = linkMapping;
+
+    if (!m_control.presenceBitmap.has_value())
+    {
+        m_control.presenceBitmap = 0;
+    }
+    *m_control.presenceBitmap |= (1 << tid);
+}
+
+std::list<uint8_t>
+TidToLinkMapping::GetLinkMappingOfTid(uint8_t tid) const
+{
+    auto it = m_linkMapping.find(tid);
+
+    if (it == m_linkMapping.end())
+    {
+        return {};
+    }
+
+    std::list<uint8_t> linkIds;
+    for (uint8_t linkId = 0; linkId < 15; linkId++)
+    {
+        if (((it->second >> linkId) & 0x0001) == 1)
+        {
+            linkIds.push_back(linkId);
+        }
+    }
+
+    return linkIds;
+}
+
+uint16_t
+TidToLinkMapping::GetInformationFieldSize() const
+{
+    // IEEE 802.11be D2.0 9.4.2.314 TID-To-Link Mapping element
+    uint16_t ret = WIFI_IE_ELEMENT_ID_EXT_SIZE; // Element ID Extension
+    ret += m_control.GetSubfieldSize();
+    NS_ASSERT_MSG(m_linkMapping.empty() == m_control.defaultMapping,
+                  "Per-TID link mapping not expected if default mapping is set");
+    ret += WIFI_LINK_MAPPING_PER_TID_SIZE_B * (m_linkMapping.size());
+    return ret;
+}
+
+void
+TidToLinkMapping::SerializeInformationField(Buffer::Iterator start) const
+{
+    // IEEE 802.11be D2.0 9.4.2.314 TID-To-Link Mapping element
+    m_control.Serialize(start);
+    NS_ASSERT_MSG(m_linkMapping.empty() == m_control.defaultMapping,
+                  "Per-TID link mapping not expected if default mapping is set");
+
+    for (const auto& [tid, linkMapping] : m_linkMapping)
+    {
+        start.WriteHtolsbU16(linkMapping);
+    }
+}
+
+uint16_t
+TidToLinkMapping::DeserializeInformationField(Buffer::Iterator start, uint16_t length)
+{
+    auto i = start;
+    uint16_t count = 0;
+    auto nCtrlOctets = m_control.Deserialize(i);
+    NS_ASSERT_MSG(nCtrlOctets <= length, "Tid-to-Link Mapping deserialize error");
+    i.Next(nCtrlOctets);
+    count += nCtrlOctets;
+    m_linkMapping.clear();
+    if (m_control.presenceBitmap.has_value())
+    {
+        NS_ABORT_MSG_IF(m_control.defaultMapping,
+                        "Default mapping should not be set when presence bitmap is present");
+        const auto presenceBitmap = m_control.presenceBitmap.value();
+        for (uint8_t tid = 0; tid < 8; tid++)
+        {
+            if (((presenceBitmap >> tid) & 0x01) == 1)
+            {
+                m_linkMapping[tid] = i.ReadLsbtohU16();
+                count += 2;
+            }
+        }
+    }
+
+    NS_ABORT_MSG_IF(count != length,
+                    "TID-to-Link Mapping Length (" << +length
+                                                   << ") differs "
+                                                      "from actual number of bytes read ("
+                                                   << +count << ")");
+    return count;
+}
+
+} // namespace ns3
